/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1997, ADLink Technology Inc.  All rights reserved.  ;;
;;									   ;;
;;	File Name   :	PCI7250.C					   ;;
;;	Purpose     :	Read the current exist PCI-7250/PCI-7251 status    ;;
;;	Date	    :	6/18/1997					   ;;
;;	Revision    :	1.00						   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "aclerr.h"
#include "acl_pci.H"

void main( void )
{
    I16     i, j, err;
    U16     existCards;
    U16     pci_CurCardNo;
    PCI_INFO	    info;

    /*---------- PCI-7250 initial ------------------------------------------*/
    err = _7250_Initial(&existCards, &info);
    if(err != ERR_NoError) {
	printf("PCI BIOS does not exist\n");
	exit(1);
    }
    if(existCards == 0) {
	printf("PCI-7250 does not exist\n");
	exit(1);
    }
    for(i=0; i<existCards; i++) {
	printf("\n>>>>>> PCI-7250 card #%d exist, Base Address = %04X, IRQ = %d <<<<<<\n",
		i+1, info.baseAddr[i], info.irqNo[i]);
	for(j=0; j<3; j++) {
	    if(_7251_Check_Exist(i, j+1) == PCI_7251_EXIST) {
		printf("Extended #%d PCI-7251 exist\n", j+1);
	    } else {
		printf("Extended #%d PCI-7251 does not exist\n", j+1);
	    }
	}
    }
}
