/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1997, ADLink Technology Inc.  All rights reserved.  ;;
;;                                                                         ;;
;;      File Name   :   DO_DEMO1.C                                         ;;
;;      Purpose     :   Demo program of PCI-7250 digital output            ;;
;;      Date        :   6/18/1997                                          ;;
;;      Revision    :   1.00                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "aclerr.h"
#include "std.h"
#include "video.h"
#include "key.h"
#include "acl_pci.H"

#define ACL_TitleColor      (WHITE | bgcolor(GREEN))
#define ACL_TextColor       (WHITE | bgcolor(BLUE))
#define ACL_BkColor         (BLUE | bgcolor(BLUE))
#define ACL_MsgColor        (RED|INVERSE)
#define ACL_ProgColor       (WHITE | bgcolor(BROWN))


U8  *acl_Title = "****** PCI-7250 DO DEMO (Single) ******";
U8  *acl_Copyright="Copyright (c) 1995-1997, ADLink Technology Inc.  All rights reserved.";

struct  {
    U16 extExist[3];
} pci_ExtInfo[MAX_PCI_CARDS];

/*----------------------------------------------------------------------*/

void showMessage(std_UByte *msg)
{
    video_ClearBox(24, 0, 24, 79, INVERSE);
    video_CenterPutStr(24, msg, ACL_MsgColor);
}
/*----------------------------------------------------------------------*/

void main( void )
{
    I16     i, j, err, row, col, key;
    U16     doData, tmpBuf[80];
    U16     existCards, curCardNo;
    PCI_INFO        info;

    /*---------- PCI-7250 initial ------------------------------------------*/
    err = _7250_Initial(&existCards, &info);
    if(err != ERR_NoError) {
        printf("PCI BIOS does not exist\n");
        exit(1);
    }
    if(existCards == 0) {
        printf("PCI-7250 does not exist\n");
        exit(1);
    }
    for(i=0; i<existCards; i++) {
        for(j=0; j<3; j++) {
            pci_ExtInfo[i].extExist[j] = _7251_Check_Exist(i, j+1);
        }
    }
    /*----------------------------------------------------------------------*/
    video_Initial();
    video_CursorOff();
    video_Box(VIDEO_SINGLE, 0, 0,  4, 79, ACL_TitleColor);
    video_Box(VIDEO_DOUBLE, 5, 0, 23, 79, ACL_TextColor);
    video_ClearBox(24, 0, 24, 79, INVERSE | BLUE);
    video_CenterPutStr(1, acl_Title, ACL_TitleColor);
    video_CenterPutStr(3, acl_Copyright, ACL_TitleColor);
    showMessage(">>> Press any key to change DO value, <Esc> to quit <<<");
    row = 10;
    col = 20;
    video_PutStr(row,  col, "PCI-7250 #0 output DO_PORT0 =", ACL_TextColor);
    video_PutStr(row+1,col, "PCI-7251 #1 output DO_PORT1 =", ACL_TextColor);
    video_PutStr(row+2,col, "PCI-7251 #2 output DO_PORT2 =", ACL_TextColor);
    video_PutStr(row+3,col, "PCI-7251 #3 output DO_PORT3 =", ACL_TextColor);

    doData = 1;
    curCardNo = PCI_CARD1;

    _7250_DO(curCardNo, DO_PORT0, doData);      // DO for PCI-7250
    sprintf(tmpBuf,"%02X", doData);
    video_PutStr(row, col+30, tmpBuf, INVERSE);

    for(j=0; j<3; j++) {
        if(pci_ExtInfo[curCardNo].extExist[j] == PCI_7251_EXIST) {
            _7250_DO(curCardNo, j+1, doData);
            sprintf(tmpBuf,"%02X", doData);
            video_PutStr(row+j+1, col+30, tmpBuf, INVERSE);
        } else {
            video_PutStr(row+j+1, col+30, "not exist", ACL_TextColor);
        }
    }

    key = !KEY_ESC;
    do {
        if(key_Hit()) {
            key = key_Get();
            doData++;
            if(key == KEY_ESC) doData = 0;
            _7250_DO(curCardNo, DO_PORT0, doData);
            sprintf(tmpBuf, "%02X", doData);
            video_PutStr(row, col+30, tmpBuf, INVERSE);
            for(j=0; j<3; j++) {
                if(pci_ExtInfo[curCardNo].extExist[j] == PCI_7251_EXIST) {
                    _7250_DO(curCardNo, j+1, doData);
                    sprintf(tmpBuf, "%02X", doData);
                    video_PutStr(row+j+1, col+30, tmpBuf, INVERSE);
                }
            }
        }
    } while(key != KEY_ESC);
    video_CursorOn();
    video_ClearBox(24, 0, 24, 79, NORMAL);
}
